local K, C = unpack(select(2, ...))
local Module = K:GetModule("Automation")

local _G = _G

local BNGetGameAccountInfoByGUID = _G.BNGetGameAccountInfoByGUID
local C_QuestSession_GetSessionBeginDetails = _G.C_QuestSession.GetSessionBeginDetails
local IsCharacterFriend = _G.IsCharacterFriend
local IsGuildMember = _G.IsGuildMember
local UnitGUID = _G.UnitGUID
local UnitName = _G.UnitName
local hooksecurefunc = _G.hooksecurefunc

local C_QuestSession_SendSessionBeginResponse = _G.C_QuestSession.SendSessionBeginResponse

local function SetupAutoPartySyncAccept(self)
	local details = C_QuestSession_GetSessionBeginDetails()
	if details then
		for _, unit in ipairs({"player", "party1", "party2", "party3", "party4"}) do
			if UnitGUID(unit) == details.guid then
                local requesterName = UnitName(unit)
				if BNGetGameAccountInfoByGUID(requesterName) or IsCharacterFriend(requesterName) or IsGuildMember(requesterName) then
                    self.ButtonContainer.Confirm:Click() -- QuestSessionManager.StartDialog.ButtonContainer
                    C_QuestSession_SendSessionBeginResponse(true)
				end
				return
			end
		end
	end
end

function Module:CreateAutoPartySyncAccept()
	if C["Automation"].AutoPartySyncAccept then
		hooksecurefunc(QuestSessionManager.StartDialog, "Show", SetupAutoPartySyncAccept())
	end
end